config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"

Rails.application.routes.draw do
  # Administrate
  constraints CanAccessAdmin do
    namespace :admin do
      root controller: "users", action: :index
      resources :users do
        post :impersonate, on: :member
      end
      get :stop_impersonating, to: :stop_impersonating, controller: "users"
      mount Flipper::UI.app(Flipper) => "/flipper", as: "flipper"
      mount Sidekiq::Web => "/sidekiq", as: "sidekiq"
      mount LetterOpenerWeb::Engine, at: "/letter_opener", as: "letters" if Rails.env.development?
    end
  end

  mount StripeEvent::Engine, at: "/stripe/webhook"

  devise_for :users,  path: "",
                      path_names: {
                        sign_in: "sign-in",
                        sign_out: "sign-out",
                        sign_up: "sign-up"
                      },
                      controllers: {
                        registrations: "users/registrations"
                      }

  unauthenticated :user do
    devise_scope :user do
      root to: "pages#features"
    end
  end

  # Signed out (marketing) pages
  get "pricing", to: "pages#pricing"
  get "about", to: "pages#about"
  get "cancelled", to: "pages#cancelled"

  # Signed in pages
  authenticated :user do
    root to: "dashboard#show", as: "dashboard"
    get "pro", to: "pages#pro"
  end

  # Avatars
  patch "avatars", to: "avatars#update"
  delete "avatar", to: "avatars#destroy"

  # Subscription stuff
  get "billing", to: "subscriptions#show"
  get "subscribe", to: "subscriptions#new"
  patch "subscriptions", to: "subscriptions#update"
end

app/views/pages/about.haml
%h1 Tell people about your app!

%p pages#about

app/views/pages/cancelled.haml
%h1 Your account has been cancelled :'(

%p Put pictures of sad puppies here. Maybe a small survey about why they cancelled.

app/views/pages/features.haml
%h1 Tell people about your features!

%p pages#features

app/views/pages/pricing.haml
%h1 Tell people about your pricing!

%p pages#pricing

.card-group.row.justify-content-md-center
  .card.col.col-lg-4
    .card-img-top
      %h1.text-center Basic
    .card-body
      %h5.card-title.text-center
        $9.00 USD
        %small /month
      .card-text
        %ul.list-group.list-group-flush
          %li.list-group-item
            = icon(:check)
            Get access
    .card-body
      = link_to 'Get Basic', new_registration_path(resource_name, plan_id: Product.active&.first&.plans&.active&.first&.id), class: 'btn btn-primary btn-block'

  .col.col-1
  .card.col.col-lg-4
    .card-img-top
      %h1.text-center Pro
    .card-body
      %h5.card-title.text-center
        $15.00 US
        %small /month
      .card-text
        %ul.list-group.list-group-flush
          %li.list-group-item
            = icon(:check)
            Get access
          %li.list-group-item
            = icon(:check)
            Access to Pro page
    .card-body
      = link_to 'Get PRO', new_registration_path(resource_name, plan_id: Product.active&.second&.plans&.active&.first&.id), class: 'btn btn-primary btn-block'

app/views/pages/pro.haml
%h1 Welcome to the coveted Pro Page!

%p
  You can only see this page if you have the
  %code pro
  role. The only way to get the pro role is if a Stripe webhook (
  %code> customer.subscription.updated
  ) reports that the customer subscription has been updated and has the plan which has the
  %code pro
  associated_role. Neat, right?